<template>
  <div>
    <v-row class="navQuestions my-4 mx-8" align="center" no-gutters>
      <v-spacer />
      <v-btn
        v-if="userRole == 'admin' || userRole == 'teacher'"
        small
        color="primary"
        class="mr-4"
        elevation="0"
        @click="handleNewTest"
      >
        Nova Prova
        <v-icon small right class="ml-3">mdi-plus</v-icon>
      </v-btn>
    </v-row>
    <!-- Tabela -->
    <v-data-table
      class="elevation-1 px-12 pb-6"
      calculate-widths
      :headers="headers"
      :items="tests"
      :footer-props="{ itemsPerPageText: 'Provas por página' }"
    >
      <!-- Ações -->
      <template v-slot:[`item.actions`]="{ item }">
        <div class="ehqTable">
          <v-tooltip
            v-if="(userRole == 'teacher' || userRole == 'admin') && !item.done"
            bottom
            color="primary"
          >
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="onlyShowTest(item)">mdi-eye</v-icon>
            </template>
            <span><b>Ver </b> prova</span>
          </v-tooltip>

          <v-tooltip bottom color="primary">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="handleShowResult(item)">mdi-chart-bar</v-icon>
            </template>
            <span><b>Ver</b> Desempenho</span>
          </v-tooltip>

          <v-tooltip
            v-if="
              (userRole == 'admin' || userRole == 'teacher') &&
                compareData < compareDataMethod(item.initialDate)
            "
            bottom
            color="primary"
          >
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="handleEditTest(item)">mdi-pencil</v-icon>
            </template>
            <span><b>Editar</b> prova</span>
          </v-tooltip>

          <v-tooltip
            v-if="
              (userRole == 'admin' || userRole == 'teacher') &&
                compareData < compareDataMethod(item.initialDate)
            "
            bottom
            color="primary"
          >
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="handleDeleteTest(item)">mdi-delete</v-icon>
            </template>
            <span><b>Deletar</b> prova</span>
          </v-tooltip>

          <span v-if="compareData > compareDataMethod(item.endDate)">
            <v-btn
              style="pointer-events: none;"
              class="my-1"
              color="primary"
              outlined
              elevation="0"
              x-small
            >
              Já realizada
            </v-btn>
          </span>

          <span
            v-if="
              compareData > compareDataMethod(item.initialDate) &&
                compareData < compareDataMethod(item.endDate)
            "
          >
            <v-btn
              style="pointer-events: none;"
              class="my-1"
              color="blue"
              outlined
              elevation="0"
              x-small
            >
              Acontecendo
            </v-btn>
          </span>

          <v-btn
            v-if="!item.done && userRole == 'monitor'"
            class="my-1"
            outlined
            color="primary"
            elevation="0"
            x-small
            @click="showTest(item)"
            >Iniciar prova</v-btn
          >
        </div>
      </template>
      <!-- Turmas -->
      <template v-slot:[`item.class`]="{ item }">
        <v-row justify="center" v-for="turma in item.class" :key="turma.id">
          <v-chip small>
            <span style="font-size:0.75rem">
              <b>{{ turma.name }}</b>
            </span>
          </v-chip>
        </v-row>
      </template>
      <!-- Questões -->
      <template v-slot:[`item.questions`]="{ item }">
        {{ item.questions.length }}
      </template>
      <!-- Data inicial -->
      <template v-slot:[`item.initialDate`]="{ item }">
        <span v-html="convertData(item.initialDate)" />
      </template>
      <!-- Data inicial -->
      <template v-slot:[`item.endDate`]="{ item }">
        <span v-html="convertData(item.endDate)" />
      </template>
    </v-data-table>

    <!-- INICIO DOS DIALOGS -->
    <v-dialog
      v-model="dialogManageTest"
      :width="widthManageTestDialog"
      @keydown.esc="closeDialogManageTest"
      @click:outside="closeDialogManageTest"
    >
      <ManageTests
        ref="refTest"
        :manageTest="manageTest"
        :itemToEdit="itemToEdit"
        @handleClose="closeDialogManageTest"
        @addTest="addTest"
        @editTest="editTest"
        @goTab0="widthManageTestDialog = '800px'"
        @goTab1="widthManageTestDialog = '95%'"
      />
    </v-dialog>
    <v-dialog
      v-if="dialogShowPerformance"
      v-model="dialogShowPerformance"
      color="white"
      fullscreen
      persistent
    >
      <ShowResult
        ref="refPerformance"
        :test="testToView"
        :userRole="userRole"
        :onlyView="onlyView"
        :classes="shareClass"
        @handleClose="closeResultTest"
      />
    </v-dialog>
    <!-- Confirma deletar usuario -->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="confirmDeleteQuestion"
    />
  </div>
</template>

<script>
import ManageTests from './ManageTests.vue'
import ShowResult from './ShowResult.vue'
import Teacher from '../../../servicesEhq/req/teacher'
import { Utils } from '../../../utils/utils'

export default {
  name: 'MainTeacher',
  props: {
    userRole: { type: String, default: '' },
  },
  computed: {},
  components: { ManageTests, ShowResult },
  data: () => ({
    headers: [
      { text: 'Título', align: 'center', sortable: false, value: 'title', width: '17%' },
      {
        text: 'Numero Questões',
        align: 'center',
        sortable: false,
        value: 'questions',
        width: '13%',
      },
      {
        text: 'Turmas',
        align: 'center',
        sortable: false,
        value: 'class',
        width: '17%',
      },

      {
        text: 'Data de início',
        align: 'center',
        sortable: false,
        value: 'initialDate',
        width: '17%',
      },
      {
        text: 'Data de fim',
        align: 'center',
        sortable: false,
        value: 'endDate',
        width: '17%',
      },
      { text: 'Ações', align: 'center', sortable: false, value: 'actions', width: '15%' },
    ],
    //tipo de questões: summation, multipleChoice, objective, trueOrFalse, dissertation
    tests: [],
    alert: {
      status: false,
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    itemToDelete: {},
    itemToView: {},
    itemToEdit: {},
    testToView: {},
    onlyView: false,
    manageTest: 'add', //add or edit
    dialogManageTest: false,
    dialogShowTest: false,
    dialogShowPerformance: false,
    areas: [],
    userInfo: {},
    widthManageTestDialog: '800px',
    compareData: '',
    shareClass: [],
  }),

  async created() {
    this.generateData()
    this.userInfo = await this.$getItem('userEHQ')
    if (this.userInfo.type == 'teacher') {
      await this.readAllTests(this.userInfo.id)
    }
  },
  methods: {
    // FRONTEND BÁSICO
    generateData() {
      let actualData = new Date()
      actualData.getTime()
      this.compareData = actualData
    },

    compareDataMethod(item) {
      let newData = new Date(item)
      let convert = newData.getTime()
      return convert
    },

    // deletar questão
    handleDeleteTest(item) {
      this.itemToDelete = item
      this.alert.message = `Deseja <b>deletar</b> a questão "${item.title}" ?`
      this.alert.status = true
    },
    async confirmDeleteQuestion() {
      await this.deleteTest(this.itemToDelete.id)
      this.alert.status = false
    },

    //nova questão
    handleNewTest() {
      this.manageTest = 'add'
      this.dialogManageTest = true
    },

    //editar questão
    async handleEditTest(item) {
      this.itemToEdit = item
      this.manageTest = 'edit'
      this.dialogManageTest = true
    },

    // métodos p/ nova questão e editar questão
    closeDialogManageTest() {
      this.$refs.refTest.resetData()
      this.dialogManageTest = false
      this.manageTest = 'add'
      this.itemToEdit = { questions: [] }
    },

    //add novo teste
    async addTest(item) {
      let teacherId = this.userInfo.id
      let questions = []
      item.questions.forEach((question) => {
        questions.push({ id: question.id, weight: Number(question.weight) })
      })

      let data = {
        teacherId: teacherId,
        instructions: item.instructions,
        initialDate: item.initialDate,
        endDate: item.endDate,
        title: item.title,
        class: item.class,
        questions: questions,
        monitors: item.monitors,
      }

      await this.createTest(data)

      this.closeDialogManageTest()
    },

    // edit teste
    async editTest(item) {
      await this.editTestSave(
        item.id,
        item.initialDate,
        item.endDate,
        item.title,
        item.instructions
      )
      this.closeDialogManageTest()
    },

    // APENAS VISÃO da prova
    onlyShowTest(item) {
      this.dialogShowPerformance = true
      this.testToView = item
      this.onlyView = true
    },

    //ver RESULTADOS
    handleShowResult(item) {
      this.shareClass = item.class
      this.dialogShowPerformance = true
      this.testToView = item
    },

    closeResultTest() {
      this.dialogShowPerformance = false
      this.onlyView = false
      this.testToView = { id: '', questions: [] }
    },

    convertData(data) {
      let newData = new Date(data)
      let convert = newData.getTime()
      return Utils.compareDate(convert)
    },

    // INTEGRAÇÃO BACKEND
    async readAllTests(teacherId) {
      this.$store.commit('user/UPDATE_LOADING', true)
      let req
      try {
        req = await Teacher.readAllTests(teacherId)
        if (req.success) {
          this.tests = req.data.tests
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      return req
    },

    async readTestById(testId) {
      let req
      try {
        req = await Teacher.readTestById(testId)
        if (req.success) console.log('carregou teste por id')
      } catch (e) {
        console.error(e)
      } finally {
      }
      return req
    },

    async createTest(data) {
      this.$store.commit('user/UPDATE_LOADING', true)
      try {
        let req = await Teacher.createTest(data)
        if (req.success) {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Prova foi <b>criada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          await this.readAllTests(this.userInfo.id)
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async editTestSave(id, initialDate, endDate, title, instructions) {
      this.$store.commit('user/UPDATE_LOADING', true)
      try {
        let req = await Teacher.updateTest(id, initialDate, endDate, title, instructions)
        if (req.success) {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Prova editada <b>adicionada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          await this.readAllTests(this.userInfo.id)
        } else {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Não é possivel <b>editar</b> uma prova já realizada.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async deleteTest(id) {
      this.$store.commit('user/UPDATE_LOADING', true)
      try {
        let req = await Teacher.deleteTest(id)
        if (req.success) {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Prova <b>deletada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          await this.readAllTests(this.userInfo.id)
        } else {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Não é possivel <b>deletar</b> uma prova já realizada.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>

<style>
.viewQuestionStyle:hover {
  font-weight: 600;
  cursor: pointer;
}
</style>
